<template>
  <div class="auth-container">
    <div class="row">
      <div class="col-6 mx-auto auth-form">
        <h3>Calendrier - connexion</h3>
        <form @submit.prevent="submitLogin()">
          <p v-if="message">{{message}}</p>
          <div class="form-group my-2">
            <input type="text" class="form-control" v-model="userEmail" placeholder="Votre email" value />
          </div>
          <div class="form-group my-2">
            <input type="password" class="form-control" v-model="userPassword" placeholder="Votre mot de passe" value />
          </div>
          <div class="form-group my-2">
            <v-btn type="submit" color="primary">Se connecter</v-btn>
          </div>
          <div class="form-group">
            <v-btn text @click="DisplayModal = true">Mot de passe oublié ?</v-btn>
          </div>
        </form>
        <v-btn color="error" class="mt-4" @click="goToRegister()">S'inscrire</v-btn>
        <!-- <button class="not-sub btn-submit" ></button> -->
      </div>
    </div>
    <ModalMail v-if="DisplayModal" :model="DisplayModal"/>

  </div>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';
import AuthService from '../../services/authService';
import ModalMail from './ModalMail.vue';

@Component({

  components: {
    ModalMail
  }
})
export default class Login extends Vue{

  private _authService: AuthService = null;
  private DisplayModal: Boolean = false;
  private userEmail: string = "";
  private userPassword: string = "";
  message = '';
  origin = null;



  mounted(){
    this.origin = this.$route.query.origin;
    this._authService = new AuthService();
  }
  goToRegister(){
    this.$router.push({name: "register"})
  }
  submitLogin(){
    this._authService.loginUser(this.userEmail, this.userPassword).then(user => {
      this.message = "";
      
      if(user.isValid) {
        if(!this.origin) {
          this.$router.push({name: "home"})
        } else {
          this.$router.push(this.origin);
        }
      } else {
        this.$router.push({name: "awaitValidation"});
      }
       
    }).catch(() => {
      this.message = "L'email et/ou le mot de passe semblent incorrects."
    })
  }
}
</script>
<style lang="css">
</style>
